<template>
    <div>
        <QuizQuestion @clickAnswer="handleClickAnswer" v-bind:question="questions && questions[currentQuestion]"/>
    </div>
</template>

<script>
    import Question from "../scripts/Question";
    import $ from 'jquery';
    import QuizQuestion from "../components/QuizQuestion";

    export default {
        name: "GamePlay",
        components: {
            QuizQuestion
        },
        data: function() {
            return {
                currentQuestion: 0,
                playerName: this.$route.params.name,
                answers: [],
                questions: undefined
            };
        },
        methods: {
            getQuizQuestions: function () {
                try {
                    $.ajax({
                        url: 'https://opentdb.com/api.php?amount=10',
                        method: 'GET'
                    }).done(data => {
                            this.questions = data.results.map(question => {
                                return new Question(question);
                            });
                        })
                } catch(err) {
                    console.error(err);
                    throw err;
                }
            },
            handleClickAnswer: function (answer) {
                this.currentQuestion++;
                this.answers.push(answer);
                if(this.answers.length === this.questions.length) {
                    this.$router.push({name: 'game-over', params: { name: this.playerName, questions: this.questions, answers: this.answers }});
                }
            }
        },
        created() {
            this.getQuizQuestions();
        }
    }
</script>

<style scoped>
</style>